Subject: Jim Fulton's comments

From: <[email-masked]>
Date: Fri, 22 May 87 13:07:07 EDT

From: <[email-masked]>
Date: Fri, 22 May 87 11:17:24 -0400

Mr. Fulton claims that creating good user interfaces
requires great skill and artistic talent - I whole-heartedly
agree.  Ideed, I said so in my first comment.  Further,
he accurately  pointed out that a "large, complex library
of widgets" won't make good interfaces.  Again, I completely
agree.

What he and several other respondents seem to be missing, however,
is the vital importance that different applications running
under the "Industry Standard" window system [X111,NeWS,etc, you pick]
(I know, I know, but it will happen anyway)

	NOT,  repeat NOT

have different user interfaces!!!!!

The last thing in the world I want is to have three different
applications windows open on my screen, each with a different
user-interface paradigm!!!

	THIS WILL BE FATAL!

I believe one of the points to having windows in the first place
is so one program doesn't take over the world, but yet, all
these interfaces, and I infer their designers, believe
their program will be the only one being used at any one time!

This will lead to a replay of the current situation - every
program has a different command language, only now it will
be visual, not linear.

A bit of apocrypha:

A survey was done in the moderatly-recent past of IBM PC and
Macintosh users regarding how much software they have,
how much software they really USE, and how long they spent
learning to use it.  Note they interviewed REAL PEOPLE,
not programmers.

PC users generally have 8-10 or so pieces of software.
They generally feel facile with only 2 or 3 pieces.
They spend 20-40 HOURS learning to use EACH one.
(This is probably why they don't learn more of them!)

Mac users generally have 15-20 or so pieces of software.
They generally feel facile with 10-13 of them.
They spent 30 minutes to 1 hour learning the first one,
	but only about 20 MINUTES learning the additional ones.

This ease of learning was universally ascribed to the commonality
of the user interface BETWEEN programs.

If software running on mid- and high-end workstations is ever going
to be a broad commercial sucess, instead of an academic nicety
or a select vertical market (these two are probably redundant!),
this issue must be considered.

Quite frankly, given the choice between a system with lots of
individually good, but collectively randomly-behaved software,
and a system which runs a lot of essentially-equally-powerful
software with a very consistant interface, the randoms have
little hope of commercial sucess. This is vitally important
to those of us interested in writing and SELLING high-quality
software so we can make a good living doing so.

Oh yes, as Henry Spencer pointed out, and I cannot agree with more,
There is no tool like the Right One for the job.  But that doesn't
make a hammer good for putting in screws because it does it so fast!

	Yours for the *right* tool, and clearer windows,

	-Mike O'Dell

---

From: [email-masked] (John Gilmore)
Date: Wed, 27 May 87 04:15:05 EDT

Date: Tue, 26 May 87 03:06:47 PDT
From: [email-masked] (John Gilmore)

In article <[email-masked]>, Mike O'Dell writes:
> little hope of commercial sucess.

I absolutely agree.  I have had an old Unipress Emacs with mouse support
for years.  I cannot use its mouse support because it is different
from the mouse support provided by the basic window system (SunView)
and I can't remember what it does.  So I end up copying text around
into files and inserting the file in Emacs, because it doesn't have
a Stuff command in the mouse menu like all the other windows.

NeWSfolks at Sun, please remember to define a good user interface for
NeWS.  When the interpreter works and is complete and fast, you are
only half done.  If you don't provide a user interface at least as good
as SunView, everybody will write their own, and we users will be
mightily confuzzed.  (SunView tends to suffer from too many frobs and
too little effort put into simplicity and ease of use -- try the
so-called editor sometime -- but its advantage is its ubiquity.
Applications CAN'T override it so they learn to live with it.)

This job has clearly not been done in the NeWS prerelease tape,
though I don't fault the prerelease for the lack of it -- something had
to go out the door to get people familiar with programming in NeWS.  A
very good skeleton is there; it just needs flesh.

---

From: [email-masked] (Jim Fulton)
Date: Wed, 27 May 87 04:16:39 EDT

Date: 26 May 87 19:31:32 GMT
From: [email-masked]  (Jim Fulton)

I think that everyone is in violent agreement that having a good common user
interface is VERY important.  The point that I was trying to make in previous
postings was that this is NOT something that should be built into the window
system specification.  I strongly suspect (and hope) that commercial
applications written for the "Industry Standard Window Systems" will use the
common toolboxes and "play by the rules" so that they will work well with a
*variety* of User Interface Managers (which in themselves will become avenues
for commercial development).  However, there is and always will be room for
growth and the development of new ideas.

The barbs being flung at X and NeWS should instead be aimed at the toolkits
that will reside on top of them.  It is a much harder problem than first
appears given the wide range of display, CPU, and network hardware that will
used.

							Jim Fulton
							Cognition Inc.
                                                        900 Tech Park Drive
uucp:  ...!{mit-eddie,talcott,necntc}!ci-dandelion!jim  Billerica, MA  01821
arpa:  [email-masked], [email-masked]         (617) 667-4800

---

From: [email-masked] (Matt Landau)
Date: Fri, 29 May 87 17:52:49 EDT

Date: 28 May 87 04:27:47 GMT
From: [email-masked]  (Matt Landau)
Subject: Re: Jim Fulton's comments
To: [email-masked]

In comp.windows.news (<[email-masked]>), [email-masked]
(John Gilmore) writes:
>mightily confuzzed.

Last time I heard anything official from Sun, the party line was that
NeWS would ship with a SunView toolkit, so that applications programmed
to SunView specs would be source-code compatible with NeWS.  Has there
been some change in plan recently?
--
 Matt Landau			    "Waiting for a flash of enlightenment
 [email-masked]	     in all this blood and thunder..."

 applications on all machines. Obviously we
are barely ready to settle on a standard programming interface (i.e., toolkit)
either. However, the point is well-taken that a bunch of different applications
(regardless if they all run under NeWS, X, MS-windows, or even Mac windows)
with different user interfaces is a real lose.

	ONe perspective that helps is to separate out the needs of the
research community from the commercial end-user. The research community wants
to be able to experiment with different user-interface designs within the
same windowing paradigm (NeWS and/or X), but the commercial end-user (or
student trying to get some work done) couldn't care less about such
flexibility. A uniform interface leads to far more productive use of
application software than a bunch of applications all with their own unique,
clever user-interface designs which often conflict even at the keystroke or
mouse selection level.

So my conclusion is that the modularity/layering that NeWS/X provide is
nice for allowing experimentation and future innovation. It give vendors
and individual programers more flexibility (not necessarily less headaches).
BUt I think that at minimum each vendor should establish clear and thorough
user interface guidelines (perhaps applications should be certified) so
at least applications on the same piece of hardware will work in a similar
way. Of course, many places (especially universities) desire a
heterogeneous hardware environment to meet a diverse set of needs and
it would be nice to know you can move from machine to machine and not
have to deal with a different and potentially conflicting
user-interface. I have already experienced the pain of swithching
between several windowing environments where conventions for using the
mouse conflicted. After a while you don't care which way is better
anymore, only that there would be just one way so you could rely on
one automatic/unconscious habit to work transparently.  So this
seems to call for standards across the board for commercial
applications (buck the standard at your own risk --- some Macintosh
applications have been severely criticized for not following the
user-interface guidelines and the word gets around to consumers). Of
course all this at the risk that future innovation may be delayed (I'm
not convinced this is a big factor anyhow regarding commercial products),
nobody will be able to sue anyone else for "look and feel," and normal people
might actually enjoy using computers rather than moaning and groaning about
them.

Mark
-------

---

From: Gordon Joly <[email-masked]>
Date: Tue, 2 Jun 87 13:13:50 EDT

From: Gordon Joly <[email-masked]>
Date: Tue, 2 Jun 87 11:00:13 BST

>            [...] After a while you don't care which way is better
>one automatic/unconscious habit to work transparently. [...]
                                Mark Richer.

Mark,

It would hard to make transparent change from the SUN mouse to
the MAC mouse, since they have a different number of buttons:-).

Gordon Joly,
[email-masked]
[email-masked]